Index: extensions/GMaps/admin/gmaps_amd_warning.tpl
===================================================================
--- extensions/GMaps/admin/gmaps_amd_warning.tpl	(revision 7125)
+++ extensions/GMaps/admin/gmaps_amd_warning.tpl	(revision 7125)
@@ -0,0 +1,3 @@
+<div class='warning'>
+{$gmaps_amd_warning}
+</div>
Index: extensions/GMaps/admin/gmaps_category_maps.tpl
===================================================================
--- extensions/GMaps/admin/gmaps_category_maps.tpl	(revision 7125)
+++ extensions/GMaps/admin/gmaps_category_maps.tpl	(revision 7125)
@@ -0,0 +1,456 @@
+{known_script id="jquery.ui" src=$ROOT_URL|@cat:"themes/default/js/ui/packed/ui.core.packed.js"}
+{known_script id="jquery.ui.sortable" src=$ROOT_URL|@cat:"themes/default/js/ui/packed/ui.sortable.packed.js"}
+{known_script id="jquery.ui.dialog" src=$ROOT_URL|@cat:"themes/default/js/ui/packed/ui.dialog.packed.js"}
+{known_script id="maps.google.com/api" src="http://maps.google.com/maps/api/js?sensor=false"}
+
+
+{literal}
+
+<script type="text/javascript">
+
+
+  function assocManager ()
+  {
+    var properties = {
+      id:'',
+    }
+
+
+    /**
+     * initialize the page
+     */
+    this.init = function ()
+    {
+
+      $('#iDialogEdit')
+        .dialog(
+          {
+            autoOpen:false,
+            width:800,
+            height:450,
+            modal: true,
+            dialogClass: 'gcBgTabSheet gcBorder',
+            title: '{/literal}{"gmaps_manage_assoc"|@translate}{literal}',
+            buttons:
+              {
+                '{/literal}{"gmaps_ok"|@translate}{literal}':
+                  function()
+                  {
+                    if(checkValidity()) doUpdate();
+                  },
+                '{/literal}{"gmaps_cancel"|@translate}{literal}':
+                  function()
+                  {
+                    $('#iDialogEdit').dialog("close");
+                  }
+              }
+          }
+        );
+
+      $('#iBDAssocMapId').bind('change', changeMapDisplayType);
+
+      loadList();
+
+    }
+
+    /**
+     * called when the map is changed
+     * refresh the icon list
+     */
+    var changeMapDisplayType = function ()
+    {
+      switch($('#iBDAssocMapId option:selected').attr('dtype'))
+      {
+        case 'IC':
+        case 'IP':
+          $('#iBDAssocIconRow').show();
+          break;
+        case 'MP':
+          $('#iBDAssocIconRow').hide();
+          break;
+      }
+    }
+
+
+    /**
+     * manage the tabsheet
+     *
+     * @param String tabsheet : id of the tabsheet to display
+     */
+    this.displayTab = function (tabsheet)
+    {
+      switch(tabsheet)
+      {
+        case 'integration':
+          $('#iTabIntegration').css('display', 'block');
+          $('#iTabAssoc').css('display', 'none');
+          break;
+        case 'assoc':
+          $('#iTabIntegration').css('display', 'none');
+          $('#iTabAssoc').css('display', 'block');
+          break;
+      }
+    }
+
+
+    /**
+     * open the dialog box to edit the association properties
+     *
+     * @param String id : if set to '' => open dialogbox in 'add' mode
+     *                    otherwise edit the given association
+     */
+    this.editAssoc = function (id)
+    {
+      properties.id=id;
+      updateDialog('');
+      this.displayTab('assoc');
+      // >> because li items don't have id... :-(
+      $('#itab2 li').removeClass('selected_tab').addClass('normal_tab');
+      $('#itab2 li:first').addClass('selected_tab');
+      // <<
+
+      $('#iDialogEdit')
+        .bind('dialogopen', function ()
+          {
+            if(properties.id!='')
+            {
+              displayProcessing(true);
+
+              $.ajax(
+                {
+                  type: "POST",
+                  url: "{/literal}{$datas.urlRequest}{literal}",
+                  async: true,
+                  data: { ajaxfct:"admin.assoc.getAssoc", id:properties.id },
+                  success:
+                    function(msg)
+                    {
+                      updateDialog(msg);
+                      displayProcessing(false);
+                    }
+                }
+              );
+            }
+          }
+        )
+        .dialog("open");
+    }
+
+    /**
+     * delete an association
+     *
+     * @param String id : id of the association to delete
+     */
+    this.deleteAssoc = function (id)
+    {
+      $('#iDialogDelete')
+        .html('<br>{/literal}{"gmaps_pleaseConfirmAssoc"|@translate}{literal}')
+        .dialog(
+          {
+            autoOpen:true,
+            modal: true,
+            dialogClass: 'gcBgTabSheet gcBorder',
+            title: '{/literal}{"gmaps_deleteAssoc"|@translate}{literal}',
+            buttons:
+              {
+                '{/literal}{"gmaps_delete"|@translate}{literal}':
+                  function()
+                  {
+                    $(this).html("<br><img src='./plugins/GrumPluginClasses/icons/processing.gif'>");
+                    $.ajax(
+                      {
+                        type: "POST",
+                        url: "{/literal}{$datas.urlRequest}{literal}",
+                        async: true,
+                        data: { ajaxfct:"admin.assoc.deleteAssoc", id:id },
+                        success:
+                          function(msg)
+                          {
+                            $('#iDialogDelete').dialog("destroy");
+                            loadList();
+                          }
+                      }
+                    );
+                  },
+                '{/literal}{"gmaps_cancel"|@translate}{literal}':
+                  function()
+                  {
+                    $('#iDialogDelete').dialog("destroy");
+                  }
+              }
+          }
+        );
+    }
+
+    /**
+     * update values of the dialog box
+     *
+     * @param String items : json string ; if empty assume to reset all fields
+     *                       with blank
+     */
+    var updateDialog = function (items)
+    {
+      if(items=='')
+      {
+        $('#iBDAssocCatId').val(0);
+        $('#iBDAssocMapId').val($('#iBDAssocMapId option:first').val());
+        $('#iBDAssocApplySubCat').val('y');
+        $('#iBDAssocKmlFileUrl').val('');
+        $('#iBDAssocIcon').val($('#iBDAssocIcon option:visible:first').val());
+        $('#iBDAssocTitle').val('');
+      }
+      else
+      {
+        tmp=$.parseJSON(items);
+
+        $('#iBDAssocCatId').val(tmp.categoryId);
+        $('#iBDAssocMapId').val(tmp.mapId);
+        $('#iBDAssocApplySubCat').val(tmp.applySubCat);
+        $('#iBDAssocKmlFileUrl').val(tmp.kmlFileUrl);
+        $('#iBDAssocIcon').val(tmp.icon);
+        $('#iBDAssocTitle').val(tmp.title);
+      }
+
+      changeMapDisplayType();
+    }
+
+    /**
+     * reload the assocation list
+     */
+    var loadList = function ()
+    {
+      $('#iListAssoc').html("<br>{/literal}{'gmaps_loading'|@translate}{literal}<br><img src='./plugins/GrumPluginClasses/icons/processing.gif'>");
+
+      $.ajax(
+        {
+          type: "POST",
+          url: "{/literal}{$datas.urlRequest}{literal}",
+          async: true,
+          data: { ajaxfct:"admin.assoc.getList" },
+          success:
+            function(msg)
+            {
+              $("#iListAssoc").html(msg);
+            }
+        }
+      );
+    }
+
+
+    /**
+     * check for the validity of the map settings
+     */
+    var checkValidity = function ()
+    {
+      $('.error').removeClass('error');
+      ok=true;
+/*
+      if(checkIdValidity($('#iBDMapId').val())==false)
+      {
+        $('#iBDMapId').addClass('error');
+        alert('{/literal}{"gmaps_invalidId"|@translate}{literal}');
+        ok=false;
+      }
+*/
+      return(ok);
+    }
+
+    /**
+     * send assoc update to the server, and close the dialog box if everything
+     * is ok
+     */
+    var doUpdate = function ()
+    {
+      displayProcessing(true);
+
+      // build datas
+      datas = {
+        categoryId:$('#iBDAssocCatId').val(),
+        mapId:$('#iBDAssocMapId').val(),
+        applySubCat:$('#iBDAssocApplySubCat').val(),
+        kmlFileUrl:$('#iBDAssocKmlFileUrl').val(),
+        icon:$('#iBDAssocIcon').val(),
+        title:$('#iBDAssocTitle').val(),
+      }
+
+      $.ajax(
+        {
+          type: "POST",
+          url: "{/literal}{$datas.urlRequest}{literal}",
+          async: true,
+          data: { ajaxfct:"admin.assoc.setAssoc", id:properties.id, datas:datas },
+          success:
+            function(msg)
+            {
+              displayProcessing(false);
+
+              if(msg.match(/^[0-9]+$/i)!=null)
+              {
+                // result Ok ! => close the dialog box and reload the list
+                $('#iDialogEdit').dialog("close");
+                loadList();
+              }
+              else
+              {
+                returned=msg.split('!');
+                if(returned[0]!='') $('#'+returned[0]).addClass('error');
+                alert(returned[1]);
+              }
+            }
+        }
+      );
+    }
+
+    /**
+     * display or hide the processing flower
+     */
+    var displayProcessing = function (visible)
+    {
+      if(visible)
+      {
+        $('#iBDProcessing').css("display", "block");
+      }
+      else
+      {
+        $('#iBDProcessing').css("display", "none");
+      }
+    }
+
+    this.init();
+  }
+
+
+</script>
+
+{/literal}
+
+
+
+<h2>{'gmaps_associate_category_maps'|@translate}</h2>
+
+
+<div class='addMap'>
+  <a onclick="am.editAssoc('');">{'gmaps_add_a_new_association'|@translate}</a>
+</div>
+
+
+<table id='iHeaderListMaps' class="littlefont">
+  <tr>
+    <th>{'gmaps_category'|@translate}</th>
+    <th style="width:90px;">{'gmaps_apply_subcat'|@translate}</th>
+    <th style="width:90px;">{'gmaps_mapType'|@translate}</th>
+    <th style="width:356px;">{'gmaps_map'|@translate}</th>
+    <th style="width:90px;">{'gmaps_map_kmlfile'|@translate}</th>
+    <th width="40px">&nbsp;</th>
+  </tr>
+</table>
+
+
+
+<div id='iListAssoc' class="{$themeconf.name}">
+</div>
+<div id="iListAssocNb"></div>
+
+<div id="iDialogDelete">
+</div>
+
+<div id="iDialogEdit">
+  <div id='iBDProcessing' style="display:none;position:absolute;width:100%;height:100%;background:#000000;opacity:0.75">
+      <img src="plugins/GrumPluginClasses/icons/processing.gif" style="margin-top:100px;">
+  </div>
+
+  {$mapTabsheet}
+  <form>
+
+    <div id='iTabsContainer' style='height:100px;'>
+
+
+      <div id='iTabAssoc' style='display:none;'>
+        <table class="formtable">
+          <tr>
+            <td>{'gmaps_map'|@translate}</td>
+            <td>
+              <select id='iBDAssocMapId'>
+                  {foreach from=$datas.maps key=group item=mapGroup}
+                    <optgroup label="{'gmaps_displayTypeShort'|cat:$group|@translate}">
+                    {foreach from=$mapGroup item=map}
+                      <option value='{$map.id}' dtype='{$group}'>{$map.name}</option>
+                    {/foreach}
+                    </optgroup>
+                  {/foreach}
+              </select>
+            </td>
+          </tr>
+
+          <tr>
+            <td>{'gmaps_category'|@translate}</td>
+            <td>
+              <select id='iBDAssocCatId'>
+                  {foreach from=$datas.cats item=cat}
+                    <option value='{$cat.id}'>{$cat.name}</option>
+                  {/foreach}
+              </select>
+            </td>
+          </tr>
+
+          <tr>
+            <td>{'gmaps_apply_subcat'|@translate}</td>
+            <td>
+              <select id='iBDAssocApplySubCat'>
+                <option value='y'>{'gmaps_y'|@translate}</option>
+                <option value='n'>{'gmaps_n'|@translate}</option>
+              </select>
+            </td>
+          </tr>
+
+        </table>
+      </div>
+
+
+      <div id='iTabIntegration' style='display:none;'>
+        <table class='formtable'>
+
+          <tr id='iBDAssocTitleRow'>
+            <td>{'gmaps_map_title'|@translate}</td>
+            <td>
+              <input type="text" id='iBDAssocTitle' value='{$datas.title}' maxlength='200' size='55'>
+            </td>
+          </tr>
+
+          <tr id='iBDAssocIconRow'>
+            <td>{'gmaps_map_icon'|@translate}</td>
+            <td>
+              <select id='iBDAssocIcon'>
+                  {foreach from=$datas.icons item=icon}
+                    <option class='{$icon.type}' value='{$icon.file}'>{$icon.file}</option>
+                  {/foreach}
+              </select>
+            </td>
+          </tr>
+
+          <tr>
+            <td>{'gmaps_map_associate_kmlfile'|@translate}</td>
+            <td>
+              <input type="text" id="iBDAssocKmlFileUrl" maxlength='255' size='55' value="">
+            </td>
+          </tr>
+
+
+        </table>
+      </div>
+
+    </div>
+
+  </form>
+</div>
+
+
+
+
+
+{literal}
+<script type="text/javascript">
+  var am=new assocManager();
+</script>
+{/literal}
+
Index: extensions/GMaps/admin/gmaps_category_maps_iListMaps.tpl
===================================================================
--- extensions/GMaps/admin/gmaps_category_maps_iListMaps.tpl	(revision 7125)
+++ extensions/GMaps/admin/gmaps_category_maps_iListMaps.tpl	(revision 7125)
@@ -0,0 +1,24 @@
+<table class="littlefont">
+  {foreach from=$datas item=data}
+  <tr>
+    <td>{$data.catName}</td>
+    <td style="width:90px;">{$data.applySubCat}</td>
+    <th style="width:150px;">{$data.displayType}</th>
+    <td style="width:300px;">{$data.mapName}</td>
+    <td style="width:90px;">{$data.mapKmlFile}</td>
+
+    <td width="40px">
+      <img src="{$themeconf.admin_icon_dir}/edit_s.png"
+           class="button" alt="{'gmaps_edit'|@translate}"
+           title="{'gmaps_edit'|@translate}"
+           onclick='am.editAssoc({$data.id});'/>
+      <img src="{$themeconf.admin_icon_dir}/delete.png"
+           class="button"
+           alt="{'gmaps_delete'|@translate}"
+           title="{'gmaps_delete'|@translate}"
+           onclick='am.deleteAssoc({$data.id});'/>
+    </td>
+  </tr>
+  {/foreach}
+</table>
+
Index: extensions/GMaps/admin/gmaps_maps.tpl
===================================================================
--- extensions/GMaps/admin/gmaps_maps.tpl	(revision 7054)
+++ extensions/GMaps/admin/gmaps_maps.tpl	(revision 7125)
@@ -1,4 +1,3 @@
 {known_script id="jquery.ui" src=$ROOT_URL|@cat:"themes/default/js/ui/packed/ui.core.packed.js"}
-{known_script id="jquery.ui.sortable" src=$ROOT_URL|@cat:"themes/default/js/ui/packed/ui.sortable.packed.js"}
 {known_script id="jquery.ui.dialog" src=$ROOT_URL|@cat:"themes/default/js/ui/packed/ui.dialog.packed.js"}
 {known_script id="jquery.ui.slider" src=$ROOT_URL|@cat:"themes/default/js/ui/packed/ui.slider.packed.js"}
@@ -57,17 +56,40 @@
         );
 
-      $('#iBDMapId').bind('keyup focusout', function (event)
-        {
-          if(!checkIdValidity($(this).val()))
-          {
-            $(this).addClass('error');
-          }
-          else
-          {
-            $(this).removeClass('error');
+      $('#iBDDisplayTypeIC, #iBDDisplayTypeIP, #iBDDisplayTypeMP').bind('change',
+        function ()
+        {
+          switch($(this).val())
+          {
+            case 'IC':
+              $('#iBDZoomLevelRow').hide();
+              $('[name=fBDSizeMode]').attr('disabled', false);
+              break;
+            case 'IP':
+              $('#iBDZoomLevelRow').show();
+              $('[name=fBDSizeMode]').attr('disabled', false);
+              break;
+            case 'MP':
+              $('#iBDZoomLevelRow').show();
+              $('#iBDSizeModeF').attr('checked', true).change();
+              $('[name=fBDSizeMode]').attr('disabled', true);
+              break;
           }
         }
       );
 
+      $('#iBDSizeModeA, #iBDSizeModeF').bind('change',
+        function ()
+        {
+          switch($(this).val())
+          {
+            case 'A':
+              $('#iBDMapWidthSliderRow, #iBDMapHeightSliderRow').hide();
+              break;
+            case 'F':
+              $('#iBDMapWidthSliderRow, #iBDMapHeightSliderRow').show();
+              break;
+          }
+        }
+      );
 
       $("#iBDMapWidthSlider").slider(
@@ -326,5 +348,5 @@
      * @param String tabsheet : id of the tabsheet to display
      */
-    this.displayProp = function (tabsheet)
+    this.displayTab = function (tabsheet)
     {
       switch(tabsheet)
@@ -368,5 +390,9 @@
       properties.id=id;
       updateDialog('');
-      this.displayProp('general');
+      this.displayTab('general');
+      // >> because li items don't have id... :-(
+      $('#itab2 li').removeClass('selected_tab').addClass('normal_tab');
+      $('#itab2 li:first').addClass('selected_tab');
+      // <<
 
       $('#iDialogEdit')
@@ -458,6 +484,11 @@
       if(items=='')
       {
-        $('#iBDMapId').val('');
+        tmp={
+          sizeMode:'A',
+          displayTYpe:'IC'
+        }
         $('#iBDName').val('');
+        $('#iBDDisplayTypeIC').attr('checked', true);
+        $('#iBDSizeModeA').attr('checked', true);
         $('#iBDMapWidthSliderValue').val('470');
         $('#iBDMapHeightSliderValue').val('210');
@@ -486,6 +517,7 @@
 
         $('#iBDNumId').val(tmp.id);
-        $('#iBDMapId').val(tmp.mapId);
         $('#iBDName').val(tmp.name);
+        $('#iBDDisplayType'+tmp.displayType).attr('checked', true);
+        $('#iBDSizeMode'+tmp.sizeMode).attr('checked', true);
         $('#iBDMapWidthSliderValue').val(tmp.width);
         $('#iBDMapHeightSliderValue').val(tmp.height);
@@ -507,4 +539,5 @@
       }
 
+      $('#iBDDisplayType'+tmp.displayType+', #iBDSizeMode'+tmp.sizeMode).change();
       changeSize($('#iBDMapWidthSliderValue').val(), 'iBDMapWidthSlider');
       changeSize($('#iBDMapHeightSliderValue').val(), 'iBDMapHeightSlider');
@@ -558,11 +591,4 @@
       ok=true;
 
-      if(checkIdValidity($('#iBDMapId').val())==false)
-      {
-        $('#iBDMapId').addClass('error');
-        alert('{/literal}{"gmaps_invalidId"|@translate}{literal}');
-        ok=false;
-      }
-
       return(ok);
     }
@@ -578,6 +604,7 @@
       // build datas
       datas = {
-        mapId:$('#iBDMapId').val(),
         name:$('#iBDName').val(),
+        displayType:$('[name=fBDDisplayType]:checked').val(),
+        sizeMode:$('[name=fBDSizeMode]:checked').val(),
         width:$('#iBDMapWidthSliderValue').val(),
         height:$('#iBDMapHeightSliderValue').val(),
@@ -652,6 +679,6 @@
 <table id='iHeaderListMaps' class="littlefont">
   <tr>
-    <th style="width:150px;">{'gmaps_id'|@translate}</th>
     <th>{'gmaps_name'|@translate}</th>
+    <th style="width:150px;">{'gmaps_displayType'|@translate}</th>
     <th style="width:90px;">{'gmaps_dimensions'|@translate}</th>
     <th style="width:90px;">{'gmaps_zoomLevel'|@translate}</th>
@@ -685,23 +712,36 @@
         <table class='formtable'>
           <tr>
-            <td>{'gmaps_id'|@translate}</td>
-            <td>
-              <input type='text' id='iBDMapId' maxlength=12 size=12 value=''>
+            <td>{'gmaps_name'|@translate}</td>
+            <td>
+              <input type='text' id='iBDName' maxlength=80 size=60 value=''>
             </td>
           </tr>
 
           <tr>
-            <td>{'gmaps_name'|@translate}</td>
-            <td>
-              <input type='text' id='iBDName' maxlength=80 size=60 value=''>
-            </td>
-          </tr>
+            <td>{'gmaps_displayType'|@translate}</td>
+            <td>
+              <label><input type='radio' id='iBDDisplayTypeIC' name='fBDDisplayType' value='IC'>&nbsp;{'gmaps_displayTypeIC'|@translate}</label><br>
+              <label><input type='radio' id='iBDDisplayTypeIP' name='fBDDisplayType' value='IP'>&nbsp;{'gmaps_displayTypeIP'|@translate}</label><br>
+              <label><input type='radio' id='iBDDisplayTypeMP' name='fBDDisplayType' value='MP'>&nbsp;{'gmaps_displayTypeMP'|@translate}</label>
+            </td>
+          </tr>
+
         </table>
       </div>
 
       <div id='iTabDimensions' style='display:none;'>
+
         <table class="formtable">
           <tr>
-            <td>{'gmaps_width'|@translate}</td>
+            <td>{'gmaps_map_dimensions_are'|@translate}</td>
+            <td colspan="3">
+              <label><input type="radio" id="iBDSizeModeA" name="fBDSizeMode" value="A">&nbsp;{'gmaps_interface_dimensions_a'|@translate}</label><br>
+              <label><input type="radio" id="iBDSizeModeF" name="fBDSizeMode" value="F">&nbsp;{'gmaps_interface_dimensions_f'|@translate}</label>
+            </td>
+          </tr>
+
+          <tr id='iBDMapWidthSliderRow'>
+            <td>&nbsp;</td>
+            <td style='padding-left:30px;'>{'gmaps_width'|@translate}</td>
             <td>
               <input type="hidden" id="iBDMapWidthSliderValue" value="">
@@ -712,6 +752,7 @@
             </td>
           </tr>
-          <tr>
-            <td>{'gmaps_height'|@translate}</td>
+          <tr id='iBDMapHeightSliderRow'>
+            <td>&nbsp;</td>
+            <td style='padding-left:30px;'>{'gmaps_height'|@translate}</td>
             <td>
               <input type="hidden" id="iBDMapHeightSliderValue" value="">
@@ -775,5 +816,5 @@
       <div id='iTabZoomLevel' style='display:none;'>
         <table class='formtable'>
-          <tr>
+          <tr id='iBDZoomLevelRow'>
             <td>{'gmaps_zoomLevel'|@translate}</td>
             <td>
Index: extensions/GMaps/admin/gmaps_maps_iListMaps.tpl
===================================================================
--- extensions/GMaps/admin/gmaps_maps_iListMaps.tpl	(revision 7054)
+++ extensions/GMaps/admin/gmaps_maps_iListMaps.tpl	(revision 7125)
@@ -2,6 +2,6 @@
   {foreach from=$datas item=data}
   <tr>
-    <td style="width:150px;">{$data.mapId}</td>
     <td>{$data.name}</td>
+    <th style="width:150px;">{$data.displayType}</th>
     <th style="width:90px;">{$data.dimensions}</th>
     <th style="width:90px;">{$data.zoomLevel}</th>
Index: extensions/GMaps/gmaps_aip.class.inc.php
===================================================================
--- extensions/GMaps/gmaps_aip.class.inc.php	(revision 7054)
+++ extensions/GMaps/gmaps_aip.class.inc.php	(revision 7125)
@@ -22,4 +22,5 @@
 {
   protected $tabsheet;
+  protected $amdState;
 
   public function __construct($prefixeTable, $filelocation)
@@ -28,7 +29,19 @@
     $this->loadConfig();
     $this->configForTemplate();
+
+    $this->amdState=GMaps_root::checkAMDActivated();
+
+    $this->initRequest();
     $this->initEvents();
 
     $this->tabsheet = new tabsheet();
+
+
+    if($this->amdState!='advanced')
+    {
+      $this->tabsheet->add('amd_warning',
+                            l10n('gmaps_warning'),
+                            $this->getAdminLink()."&amp;fGMaps_tabsheet=amd_warning");
+    }
     $this->tabsheet->add('maps',
                           l10n('gmaps_maps'),
@@ -37,7 +50,15 @@
                           l10n('gmaps_associate_category_maps'),
                           $this->getAdminLink()."&amp;fGMaps_tabsheet=category_maps");
+/*
+    $this->tabsheet->add('kml_files',
+                          l10n('gmaps_kml_files_management'),
+                          $this->getAdminLink()."&amp;fGMaps_tabsheet=kml_files");
+    $this->tabsheet->add('search',
+                          l10n('gmaps_search'),
+                          $this->getAdminLink()."&amp;fGMaps_tabsheet=search");
     $this->tabsheet->add('help',
                           l10n('gmaps_help'),
                           $this->getAdminLink()."&amp;fGMaps_tabsheet=help");
+*/
   }
 
@@ -72,4 +93,7 @@
     switch($_REQUEST['fGMaps_tabsheet'])
     {
+      case 'amd_warning':
+        $this->displayAmdWarning();
+        break;
       case 'maps':
         $this->displayMaps();
@@ -77,4 +101,10 @@
       case 'category_maps':
         $this->displayCategoryMaps();
+        break;
+      case 'kml_files':
+        $this->displayKmlFiles();
+        break;
+      case 'search':
+        $this->displaySearch();
         break;
       case 'help':
@@ -116,5 +146,12 @@
 
     if(!($_REQUEST['fGMaps_tabsheet']!="maps" or
-         $_REQUEST['fGMaps_tabsheet']!="category_maps")) $_REQUEST['fGMaps_tabsheet']="maps";
+         $_REQUEST['fGMaps_tabsheet']!="category_maps" or
+         $_REQUEST['fGMaps_tabsheet']!="amd_warning"
+         //$_REQUEST['fGMaps_tabsheet']!="kml_files" or
+         //$_REQUEST['fGMaps_tabsheet']!="search" or
+         //$_REQUEST['fGMaps_tabsheet']!="help"
+         )) $_REQUEST['fGMaps_tabsheet']="maps";
+
+    if($_REQUEST['fGMaps_tabsheet']=="amd_warning" and $this->amdState=='advanced') $_REQUEST['fGMaps_tabsheet']="maps";
   }
 
@@ -137,14 +174,14 @@
     $mapTabsheet->add('general',
                           l10n('gmaps_properties_general'),
-                          '', true, "udm.displayProp('general');");
+                          '', true, "udm.displayTab('general');");
     $mapTabsheet->add('dimensions',
                           l10n('gmaps_dimensions'),
-                          '', false, "udm.displayProp('dimensions');");
+                          '', false, "udm.displayTab('dimensions');");
     $mapTabsheet->add('mapType',
                           l10n('gmaps_properties_mapType'),
-                          '', false, "udm.displayProp('mapType');");
+                          '', false, "udm.displayTab('mapType');");
     $mapTabsheet->add('zoomLevel',
                           l10n('gmaps_properties_zoomLevel'),
-                          '', false, "udm.displayProp('zoomLevel');");
+                          '', false, "udm.displayTab('zoomLevel');");
     $mapTabsheet->assign();
 
@@ -167,4 +204,37 @@
     global $template;
 
+    $template->set_filename('body_page',
+                dirname($this->getFileLocation()).'/admin/gmaps_category_maps.tpl');
+
+    $mapTabsheet = new GPCTabSheet('mapTabsheet', $this->tabsheet->get_titlename(), 'tabsheet2 gcBorder', 'itab2');
+    $mapTabsheet->add('assoc',
+                          l10n('gmaps_map_assoc'),
+                          '', false, "am.displayTab('assoc');");
+    $mapTabsheet->add('integration',
+                          l10n('gmaps_map_integration'),
+                          '', true, "am.displayTab('integration');");
+    $mapTabsheet->assign();
+
+
+    $datas=Array(
+      'urlRequest' => $this->getAdminLink('ajax'),
+      'cats' => $this->makeCategoriesTree(),
+      'maps' => $this->makeMapsList(),
+      'icons' => $this->makeIconsList(),
+    );
+    $template->assign('datas', $datas);
+
+    $template->assign_var_from_handle('GMAPS_BODY_PAGE', 'body_page');
+  }
+
+
+  /**
+   * display the kml file management page
+   *
+   */
+  protected function displayKmlFiles()
+  {
+    global $template;
+
     /*$template->set_filename('body_page',
                 dirname($this->getFileLocation()).'/admin/plugin_admin_maps.tpl');
@@ -174,9 +244,11 @@
   }
 
-  /**
-   * display the help page
-   *
-   */
-  protected function displayHelp()
+
+
+  /**
+   * display the search page
+   *
+   */
+  protected function displaySearch()
   {
     global $template;
@@ -189,4 +261,135 @@
   }
 
+
+  /**
+   * display the help page
+   *
+   */
+  protected function displayHelp()
+  {
+    global $template;
+
+    /*$template->set_filename('body_page',
+                dirname($this->getFileLocation()).'/admin/plugin_admin_maps.tpl');
+
+
+    $template->assign_var_from_handle('GMAPS_BODY_PAGE', 'body_page');*/
+  }
+
+
+
+  /**
+   * display a warning page if AMD is not installed
+   *
+   */
+  protected function displayAmdWarning()
+  {
+    global $template;
+
+    $template->set_filename('body_page',
+                dirname($this->getFileLocation()).'/admin/gmaps_amd_warning.tpl');
+
+    switch(GMaps_root::checkAMDActivated())
+    {
+      case 'none':
+      case 'inactive':
+        $template->assign('gmaps_amd_warning_inactive', sprintf(l10n('gmaps_amd_warning_inactive'), GMAPS_AMD_NEEDED));
+        break;
+      case 'basic':
+        $template->assign('gmaps_amd_warning_basic', l10n('gmaps_amd_warning_basic'));
+        break;
+    }
+    $template->assign_var_from_handle('GMAPS_BODY_PAGE', 'body_page');
+  }
+
+
+  /**
+   * build the categories tree
+   * @return Array : an array, ready to use in the template
+   */
+  private function makeCategoriesTree()
+  {
+    $returned=array(
+      array(
+        'id' => 0,
+        'name' => '-- '.l10n('gmaps_applyForAllTheGallery').' --'
+      )
+    );
+
+    $sql="SELECT id, name, global_rank
+          FROM ".CATEGORIES_TABLE."
+          ORDER BY global_rank";
+    $result = pwg_query($sql);
+    if($result)
+    {
+      while ($row = pwg_db_fetch_assoc($result))
+      {
+        $returned[]=array(
+          'id' => $row['id'],
+          'name' => str_repeat('&nbsp;&nbsp;', substr_count($row['global_rank'], '.')).$row['name']
+        );
+      }
+    }
+
+    return($returned);
+  } //makeCategoriesTree
+
+
+  /**
+   * build a maps list
+   * @return Array : an array, ready to use in the template
+   */
+  private function makeMapsList()
+  {
+    $returned=array(
+      'IC' => array(),
+      'IP' => array(),
+      'MP' => array()
+    );
+
+    $sql="SELECT id, name, displayType
+          FROM ".$this->tables['maps']."
+          ORDER BY displayType, name";
+    $result = pwg_query($sql);
+    if($result)
+    {
+      while($row = pwg_db_fetch_assoc($result))
+      {
+        $returned[$row['displayType']][]=array(
+          'id' => $row['id'],
+          'name' => $row['name']
+        );
+      }
+    }
+
+    return($returned);
+  } //makeCategoriesTree
+
+
+  /**
+   * build THE ICON LIST
+   * @return Array : an array, ready to use in the template
+   */
+  private function makeIconsList()
+  {
+    $returned=array();
+
+    $directory=scandir(GMAPS_PATH.'img/');
+    foreach($directory as $file)
+    {
+      $ext=(pathinfo($file, PATHINFO_EXTENSION));
+      if(preg_match('/^i.*(?:jpg|jpeg|png|gif)$/i', $file))
+      {
+        $returned[]=array(
+          'type' => (strtolower(substr($file,0,1))=='i')?'img':'other',
+          'file' => $file
+        );
+      }
+    }
+
+    return($returned);
+  } //makeCategoriesTree
+
+
 } //class
 
